function [C] = cost(F,x)
% Calculate the energy = cost of the labeling x
% Input: x : 1 x nV
%

nA = get_nA(F);

C = F.fA(1,1);

for a = 2:nA
	v = F.H.get_nodes(a);
	z = fliplr(x(v)); % whant first entries to go to lower bits
	%Z = sum(bitset(int32(0),1:length(z), z));
	%Z = bin2dec(num2str(z));
	Z = mbin2dec(z);
	C = C+F.fA(Z+1,a);
end

end