function H = add_edges(H,B)
%  H = add_edges(H,B) adds one or more edges specified in B to hypergraph H
%					  duplicate edges are not removed
%  
%	Input: B - [nV m] bool sparse -- New m hyper-edges specified by their
%					  adjucency matrix


H.A = [H.A logical(sparse(B))];

end