commandwindow;
run ../mtools/mpath.m
maddpath('../minsum');
%maddpath('../minsum/alg_trws');
%maddpath('../lp');
%addpath('/local/shekhovt/bin/ibm/ILOG/CPLEX_Studio125/cplex/matlab');
%addpath('c:\Program Files (x86)\IBM\ILOG\CPLEX_Studio125\cplex\matlab\x86_win32');
addpath('Z:\work\poh\submodular\matlab\');

K = 2;
N = 2;
M = N; nV = N*M;
maxd = 4;
T = N;
%gen = 'poly_KS';
gen = 'grid';
%tight = 'any';


for it = 1:100
	
	fprintf('it %i\n',it);
	seed = it;
	rand('seed',seed);
	randn('seed',seed);
	%E = hyper_energy1(H);
	
	if 1
		E = hpo_gen(N,M,maxd,T,gen,seed);
		%profile('invoke_pho_method(''L1'',E)');
		[y LB mu1 Mu] = E.full_LP();
		f = E.fA(E.H.A>0);
		
		mask = y==1;
		%E1 = E.flip_energy(mask); % want that y becomes flipped to 0
		%E1 = E1.to_multilinear(); % reparametrize to a miltilinear polynomial (unique)
		%p1 = hpo_iterative(E1,zeros(1,nV),'FLP');
		%
		%return
		Z = E.H.get_Zeta();
		%
		p = hpo_L1(E,y,'FLP');
		p1 = hpo_iterative(E,y,'FLP');
	end
	return
	
	% test conversion to multilinear
	E = hpo_gen(N,M,maxd,T,'grid',seed);
	y = logical(randi(2,1,nV)-1); % random labeling
	E1 = E.to_multilinear();
	E2 = E.flip_energy(y);
	p = repmat([0;1],1,nV);
	mask = logical(randi(2,1,nV)-1); % random labeling
	p(:,mask) = repmat(y(mask),2,1);
	[E3 pi] = E.restrict(p);
	for i=1:100
		x = randi(2,1,nV)-1; % random labeling
		v = [E.cost(x) E1.cost(x)];
		assert(v(1) == v(2)); % check equivalence
		%fprintf('%f = %f\n',v(1),v(2));
		% flip around y
		x(y) = ~x(y);
		v(3) = E2.cost(x);
		assert(v(1) == v(3)); % check equivalence
		%fprintf('%f = %f\n',v(1),v(3));
		x(mask) = y(mask);
		x1 = x(~mask);
		v = [E.cost(x) E3.cost(x1)];
		assert(v(1) == v(2)); % check equivalence
		%fprintf('; %f = %f\n',v(1),v(2));
	end
end