function E = hpo_gen_poly(nV,d,T)

H = hyper_graph1(nV,d);
E = hyper_energy1(H);
E.fA(:) = 0;
for t=1:T % T random polynomials
	v = randperm(nV); v = v(1:d); % select d variables randomly
	% how many coeffs: 2^d
	coeffs = randi(201,2^d,1)-100; % random coeffs in [-100 100];
	[H a] = H.add_edge(v);
	% all configs = all subsets, so can just assign the higher order term randomly
	E.fA(1:2^d,a) = coeffs;
end

E.H = H;

end