function E1 = flip_energy(E,mask)
% flips variables in the mask and returns the equvalent energy for the flip
%
nV = get_nV(E);
nA = get_nA(E);
H = E.H;

E1 = hyper_energy1(H);

for a=1:nA
	v = H.get_nodes(a);
	d = H.d(a);
	m = fliplr(mask(v));
	for z =0:2^d-1 % over all configurations
		x = mdec2bin(z,d);
		x(m) = ~x(m);
		z1 = mbin2dec(x);
		E1.fA(z1+1,a) = E.fA(z+1,a);
	end
end

end