classdef hyper_energy1 < base_class1
	properties
		K = 2;
		H = hyper_graph1();
		fA = sparse(0,0); %% global penalty functions
	end
	methods
		function F = hyper_energy1(varargin)
			%
			% 	hyper_energy(H,K) -- create an energy minimization problem instance eover hyper-graph H with K labels.
			% 	hyper_energy() -- empty energy object.
			%
			F.K = 2;
			F.H = hyper_graph1();
			F.fA = sparse(0,0); %% global penalty functions
			switch(nargin)
				case 0
				case 1
					H = varargin{1};
					F.H = H;
					I = nnz(H.A);
					v = randi(100,I,1);
					F.fA = sparse(size(H.A,1),size(H.A,2),nnz(H.A));
					F.fA(H.A>0) = v(:);
				otherwise
					error('wrong arguments');
			end
			%F = class(F,'hyper_energy1');
		end
	end
end